// updateDlg.cpp : implementation file
//

#include "stdafx.h"
#include "update.h"
#include "updateDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CUpdateApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CUpdateDlg dialog

CUpdateDlg::CUpdateDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUpdateDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUpdateDlg)
	m_Status_string = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CUpdateDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUpdateDlg)
	DDX_Text(pDX, IDC_STATUS_LBL, m_Status_string);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CUpdateDlg, CDialog)
	//{{AFX_MSG_MAP(CUpdateDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// file exists 

BOOL FileExists(CString fileName)
{
	BOOL result;
	CFile f;

	TRY
	{
		result = f.Open( fileName, CFile::modeRead | CFile::shareDenyNone, NULL );
	}
	CATCH(CFileException, e)
		result = false;
	END_CATCH
	if(result)
		f.Close();

	return result;
}

/////////////////////////////////////////////////////////////////////////////
// process paint messages

BOOL ProcessMessage()
{
	MSG lpMsg;
	BOOL Result;

	Result = FALSE;

	if( PeekMessage(&lpMsg, 0, WM_PAINT, WM_PAINT, PM_REMOVE) )
	{		
        TranslateMessage(&lpMsg);
	    DispatchMessage(&lpMsg);
		Result = TRUE;
	}
	return Result;
}

/////////////////////////////////////////////////////////////////////////////
// launch a program

BOOL Execute(HWND hWnd, LPCTSTR exeName, LPCTSTR startDir, LPCTSTR params)
{
	SHELLEXECUTEINFO ExecInfo;

	ExecInfo.cbSize = sizeof(SHELLEXECUTEINFO);
	ExecInfo.fMask = SEE_MASK_NOCLOSEPROCESS;
	ExecInfo.hwnd = hWnd;
	ExecInfo.lpVerb = TEXT("OPEN");
	ExecInfo.lpFile = exeName;
	ExecInfo.lpParameters = params;
	ExecInfo.lpDirectory = startDir;
	ExecInfo.nShow = SW_SHOW;

	
	return ShellExecuteEx( &ExecInfo );
}

//
// change a files extension
//
CString ChangeFileExt(LPTSTR s, LPCTSTR ext)
{
	int p;
	CString result;

	result = s;

	if((p = result.ReverseFind('.')) >= 0)
		result = result.Mid(0, p) + ext;
	else
		result = result + ext;

	return result;
}

/////////////////////////////////////////////////////////////////////////////
// Get a CStringList of files using lpFileName as the path
//
void GetDirectory(LPCWSTR lpFileName, CStringList& fileList)
{
	WIN32_FIND_DATA fileData;
	HANDLE f;

	if((f = FindFirstFile(lpFileName, &fileData)) != INVALID_HANDLE_VALUE)
	{
		do
		{
			if(! (fileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
				fileList.AddTail(fileData.cFileName);
		} while(FindNextFile(f, &fileData));
		FindClose(f);
	}
}


/////////////////////////////////////////////////////////////////////////////
// Timer Callback, makes it go
UINT m_nTimer;


void CALLBACK EXPORT TimerProc(
	HWND hWnd,      // handle of CWnd that called SetTimer
	UINT nMsg,      // WM_TIMER
	UINT nIDEvent,   // timer identification
	DWORD dwTime    // system time
)
{
	TCHAR *lpSrc = _T("\\inbox\\tundra2.exe");
	TCHAR *lpDest = _T("\\tundra\\tundra2.exe");
	TCHAR *lpAppDest = _T("\\Application\\tundra\\tundra2.exe");
	TCHAR *lpKeep = _T("\\tundra\\tundra2.old.exe");

	KillTimer(hWnd, m_nTimer);
	if(nIDEvent == 1)
	{
		CUpdateDlg *uDlg;
		
		uDlg = (CUpdateDlg *) theApp.m_pMainWnd;		// pointer to the update dialog window

		uDlg->m_Status_string = _T("Waiting for tundra2");
		uDlg->UpdateData(FALSE);
		while(FindWindow(NULL, _T("tundra2")) != NULL)
		{
			ProcessMessage();	// allow it to paint!!
			Sleep(10);		
		}
		uDlg->m_Status_string = _T("tundra2 gone!!");
		uDlg->UpdateData(FALSE);
		while(ProcessMessage());	// allow it to paint!!
		if(FileExists(lpSrc))
		{
			DeleteFile(lpKeep);
			MoveFile(lpDest, lpKeep);
			CopyFile(lpSrc, lpDest, FALSE);
			CopyFile(lpSrc, lpAppDest, FALSE);		// for cold boot!!
			Execute(theApp.m_pMainWnd->m_hWnd, lpDest, _T("\\windows\\start menu"), _T(""));
			DeleteFile(lpSrc);			// get rid of the one in the inbox
		}

		CStringList list;
		CString m_pFileName;
		POSITION pos;
		int i;

		GetDirectory(CString(INBOX_DIR) + _T("\\*.cab"), list);
		for(pos = list.GetHeadPosition(), i = 0; i < list.GetCount(); i++)
		{
			m_pFileName = list.GetNext(pos);
			// put it on start up so warm boot will install...
			DeleteFile(CString(_T("\\Windows\\StartUp\\")) + m_pFileName);
			MoveFile(CString(INBOX_DIRS) + m_pFileName, CString(_T("\\Windows\\StartUp\\")) + m_pFileName);
			// and copy to the e2 ram for cold boots...
			CopyFile(CString(_T("\\Windows\\StartUp\\")) + m_pFileName, CString(_T("\\Application\\tundra\\")) + m_pFileName, FALSE);
		}

		GetDirectory(CString(INBOX_DIR) + _T("\\*.cpy"), list);
		for(pos = list.GetHeadPosition(), i = 0; i < list.GetCount(); i++)
		{
			m_pFileName = list.GetNext(pos);

			// copy to the e2 ram, where it is run like a batch file on cold boot...
			DeleteFile(CString(_T("\\Application\\")) + m_pFileName);
			MoveFile(CString(INBOX_DIRS) + m_pFileName, CString(_T("\\Application\\")) + m_pFileName);
		}
		
		uDlg->m_Status_string = _T("Done");
		uDlg->UpdateData(FALSE);


		DeleteFile(_T("\\Windows\\update.old"));
		if(! MoveFile(_T("\\inbox\\update.exe"), _T("\\Windows\\update.old")))
			AfxMessageBox(_T("Cannot rename update.exe"), MB_OK);
		
//		CStringList dirList;
//		GetDirectory(_T("\\inbox\\*.*"), dirList);
//		for(POSITION pos = dirList.GetHeadPosition(); pos != NULL; )
		// only delete tundra2.exe now!!

		PostQuitMessage(0);
	}
}

/////////////////////////////////////////////////////////////////////////////
// CUpdateDlg message handlers

BOOL CUpdateDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	m_nTimer = SetTimer(1, 100, TimerProc);
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

